<template>
  <div class="dashboard-container">
    <Tableau
      v-if="isShowDashboard"
      ref="tableau"
      :url="url"
      :height="870"
      :width="1150"
    />
    <component :is="currentRole" />
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
import adminDashboard from './admin'
import editorDashboard from './editor'
import leaderDashboard from './leader'
import { RolesUser } from '@/utils/constantVariable'
import Tableau from './tableau'
import axios from 'axios'

export default {
  name: 'Dashboard',
  components: {
    adminDashboard,
    editorDashboard,
    leaderDashboard,
    Tableau
  },
  data() {
    return {
      RolesUser,
      currentRole: 'adminDashboard',
      url: ''
    }
  },
  computed: {
    ...mapGetters([
      'roles'
    ]),
    isShowDashboard() {
      return this.roles.includes(RolesUser.ADMIN) || this.roles.includes(RolesUser.STAFFPROV)
    }
  },
  created() {
    if (this.isShowDashboard) {
      this.initTableauAuth()
    }
    if (this.roles.includes(RolesUser.ADMIN) || this.roles.includes(RolesUser.STAFFPROV) ||
    this.roles.includes(RolesUser.STAFFKABKOTA)) {
      this.currentRole = 'adminDashboard'
    } else if (this.roles.includes(RolesUser.LEADER)) {
      this.currentRole = 'leaderDashboard'
    } else {
      this.currentRole = 'editorDashboard'
    }
  },
  methods: {
    async initTableauAuth() {
      const { data } = await axios.get(process.env.VUE_APP_DASHBOARD_API)
      const { token } = data.data || ''

      const dashboardUrl = process.env.VUE_APP_DASHBOARD_URL
      const position = dashboardUrl.indexOf('views')
      const newUrl = dashboardUrl.substr(0, position) + `trusted/${token}/` + dashboardUrl.substr(position)

      if (token) {
        this.url = newUrl
      } else {
        this.url = dashboardUrl
      }
    }
  }
}
</script>
